Index: branches/RegressionBenchmarks/HeuristicLab 3.3.sln
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab 3.3.sln	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab 3.3.sln	(revision 6968)
@@ -76,4 +76,5 @@
 		{E10F395F-C8A6-48AD-B470-9AA7A1F43809} = {E10F395F-C8A6-48AD-B470-9AA7A1F43809}
 		{B7A64A60-B538-479F-9C47-A3180C458F6C} = {B7A64A60-B538-479F-9C47-A3180C458F6C}
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C} = {4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}
 		{07486E68-1517-4B9D-A58D-A38E99AE71AB} = {07486E68-1517-4B9D-A58D-A38E99AE71AB}
 		{4AE3FC69-C575-42D2-BC46-0FAD5850EFC5} = {4AE3FC69-C575-42D2-BC46-0FAD5850EFC5}
@@ -299,4 +300,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Tests", "HeuristicLab.Tests\HeuristicLab.Tests.csproj", "{B62872C1-6752-4758-9823-751A2D28C388}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.Benchmarks-3.4", "HeuristicLab.Problems.DataAnalysis.Benchmarks\3.4\HeuristicLab.Problems.DataAnalysis.Benchmarks-3.4.csproj", "{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}"
 EndProject
 Global
@@ -1453,4 +1456,12 @@
 		{B62872C1-6752-4758-9823-751A2D28C388}.Release|x86.ActiveCfg = Release|x86
 		{B62872C1-6752-4758-9823-751A2D28C388}.Release|x86.Build.0 = Release|x86
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Release|Any CPU.Build.0 = Release|Any CPU
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Release|x64.ActiveCfg = Release|Any CPU
+		{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Benchmark.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Benchmark.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Benchmark.cs	(revision 6968)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  public abstract class Benchmark : NamedItem {
+
+    protected Benchmark() { }
+    protected Benchmark(Benchmark original, Cloner cloner)
+      : base(original, cloner) {
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/DistributionGenerator/Distribution.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/DistributionGenerator/Distribution.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/DistributionGenerator/Distribution.cs	(revision 6968)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  public abstract class Distribution : NamedItem {
+
+    public abstract Double Next();
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Generator/RegressionBenchmark.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Generator/RegressionBenchmark.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Generator/RegressionBenchmark.cs	(revision 6968)
@@ -0,0 +1,104 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  public abstract class RegressionBenchmark : Benchmark, IRegressionBenchmarkProblemDataGenerator {
+
+    protected RegressionBenchmark() { }
+    protected RegressionBenchmark(RegressionBenchmark original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    #region properties
+    public string TargetVariable { get; protected set; }
+    public Dictionary<string, IntRange> Inputvariables { get; protected set; }
+    public int AmountOfPoints { get; protected set; }
+    public IntRange TrainingPartition { get; protected set; }
+    public IntRange TestPartition { get; protected set; }
+    #endregion
+
+    protected abstract double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars);
+
+    public IDataAnalysisProblemData GenerateProblemData() {
+      //prepare dictionary
+      Dictionary<string, IList<double>> data = new Dictionary<string, IList<double>>();
+      data.Add(TargetVariable, new List<double>());
+      foreach (var variable in Inputvariables.Keys) {
+        data.Add(variable, new List<double>());
+      }
+
+      data = CalculateValues(data);
+
+      List<IList> values = new List<IList>();
+      foreach (var valueList in data.Values) {
+        values.Add((IList)valueList);
+      }
+
+      Dataset dataset = new Dataset(data.Keys, values);
+      dataset.Name = this.Name;
+
+      RegressionProblemData problemData = new RegressionProblemData(dataset, dataset.DoubleVariables.Skip(1), dataset.DoubleVariables.First());
+
+      #region set ProblemData specific parameters
+      problemData.Name = "Data generated for benchmark problem \"" + this.Name + "\"";
+
+      problemData.TargetVariableParameter.Value =
+        problemData.TargetVariableParameter.ValidValues.First(v => v.Value == TargetVariable);
+      problemData.InputVariables.SetItemCheckedState(
+        problemData.InputVariables.Single(x => x.Value == TargetVariable), false);
+
+      foreach (var variable in this.Inputvariables) {
+        problemData.InputVariables.SetItemCheckedState(
+          problemData.InputVariables.Single(x => x.Value == variable.Key), true);
+      }
+
+      problemData.TestPartition.Start = this.TestPartition.Start;
+      problemData.TestPartition.End = this.TestPartition.End;
+      problemData.TrainingPartition.Start = this.TrainingPartition.Start;
+      problemData.TrainingPartition.End = this.TrainingPartition.End;
+      #endregion
+
+      return problemData;
+    }
+
+    private Dictionary<string, IList<double>> CalculateValues(Dictionary<string, IList<double>> data) {
+      Random rand = new Random();
+      List<string> vars = new List<string>(Inputvariables.Keys);
+      for (int i = 0; i < AmountOfPoints; i++) {
+        foreach (var variable in vars) {
+          data[variable].Add(rand.NextDouble() *
+            (Inputvariables[variable].End - Inputvariables[variable].Start) +
+            Inputvariables[variable].Start);
+        }
+
+        data[TargetVariable].Add(CalculateFunction(data, vars));
+      }
+      return data;
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/HeuristicLab.Problems.DataAnalysis.Benchmarks-3.4.csproj
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/HeuristicLab.Problems.DataAnalysis.Benchmarks-3.4.csproj	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/HeuristicLab.Problems.DataAnalysis.Benchmarks-3.4.csproj	(revision 6968)
@@ -0,0 +1,115 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{4232E766-B8E4-4FC9-A665-C2D2FC5CD73C}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Problems.DataAnalysis.Benchmarks</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.DataAnalysis.Benchmarks-3.4</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Benchmark.cs" />
+    <Compile Include="DistributionGenerator\Distribution.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="RegressionBenchmarks\RationalPolynomial.cs" />
+    <Compile Include="RegressionBenchmarks\RationalPolynomialTwo.cs" />
+    <Compile Include="RegressionBenchmarks\RippleFunction.cs" />
+    <Compile Include="RegressionBenchmarks\SalustowiczFunctionTwoDimensional.cs" />
+    <Compile Include="RegressionBenchmarks\KotanchekFunction.cs" />
+    <Compile Include="Generator\RegressionBenchmark.cs" />
+    <Compile Include="RegressionBenchmarks\SalustowiczFunctionOneDimensional.cs" />
+    <Compile Include="RegressionBenchmarks\SineCosineFunction.cs" />
+    <Compile Include="RegressionBenchmarks\UnwrappedBallFunction.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
+      <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
+      <Name>HeuristicLab.Data-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
+      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
+      <Name>HeuristicLab.Parameters-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
+      <Project>{DF87C13E-A889-46FF-8153-66DCAA8C5674}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup />
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Plugin.cs.frame
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Plugin.cs.frame	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Plugin.cs.frame	(revision 6968)
@@ -0,0 +1,35 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Plugin("HeuristicLab.Problems.DataAnalysis.Benchmarks", "Provides benchmark problems to automatically generate test data.", "3.4.1.$WCREV$")]
+  [PluginFile("HeuristicLab.Problems.DataAnalysis.Benchmarks-3.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
+  public class HeuristicLabProblemsDataAnalysisBenchmarksPlugin : PluginBase {
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Properties/AssemblyInfo.cs.frame	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/Properties/AssemblyInfo.cs.frame	(revision 6968)
@@ -0,0 +1,55 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Problems.DataAnalysis.Benchmarks")]
+[assembly: AssemblyDescription("Provides benchmark problems to automatically generate test data.")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("460C6FC6-FFBB-4286-B781-06D9F56A202D")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("3.4.0.0")]
+[assembly: AssemblyFileVersion("3.4.1.$WCREV$")]
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/KotanchekFunction.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/KotanchekFunction.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/KotanchekFunction.cs	(revision 6968)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("Kotanchek function (2d)", "")]
+  public class KotanchekFunction : RegressionBenchmark {
+
+    public KotanchekFunction() {
+      Name = "Kotanchek function (2d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x1", new IntRange(0, 4)},
+        {"x2", new IntRange(0, 4)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected KotanchekFunction(KotanchekFunction original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new KotanchekFunction(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars) {
+      double x1 = data[vars.ElementAt(0)].Last();
+      double x2 = data[vars.ElementAt(1)].Last();
+      return Math.Exp(-Math.Pow(x1 - 1, 2)) / (Math.Pow(x2 - 2.5, 2) + 3.2);
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RationalPolynomial.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RationalPolynomial.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RationalPolynomial.cs	(revision 6968)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("Rational polynomial (3d)", "")]
+  public class RationalPolynomial : RegressionBenchmark {
+
+    public RationalPolynomial() {
+      Name = "Rational polynomial (3d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x1", new IntRange(0, 2)},
+        {"x2", new IntRange(1, 2)},
+        {"x3", new IntRange(1, 2)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected RationalPolynomial(RationalPolynomial original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RationalPolynomial(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars) {
+      double x1 = data[vars.ElementAt(0)].Last();
+      double x2 = data[vars.ElementAt(1)].Last();
+      double x3 = data[vars.ElementAt(2)].Last();
+      return (30 * (x1 - 1) * (x3 - 1)) / ((x1 - 10) * Math.Pow(x2, 2));
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RationalPolynomialTwo.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RationalPolynomialTwo.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RationalPolynomialTwo.cs	(revision 6968)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("RationalPolynomial2 (2d)", "")]
+  public class RationalPolynomialTwo : RegressionBenchmark {
+
+    public RationalPolynomialTwo() {
+      Name = "RationalPolynomial2 (2d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x1", new IntRange(0, 6)},
+        {"x2", new IntRange(0, 6)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected RationalPolynomialTwo(RationalPolynomialTwo original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RationalPolynomialTwo(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars) {
+      double x1 = data[vars.ElementAt(0)].Last();
+      double x2 = data[vars.ElementAt(1)].Last();
+      return (Math.Pow(x1 - 3, 4) + Math.Pow(x2 - 3, 3) - x2 + 3) / (Math.Pow(x2 - 2, 4) + 10);
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RippleFunction.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RippleFunction.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/RippleFunction.cs	(revision 6968)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("Ripple function (2d)", "")]
+  public class RippleFunction : RegressionBenchmark {
+
+    public RippleFunction() {
+      Name = "Ripple function (2d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x1", new IntRange(0, 6)},
+        {"x2", new IntRange(0, 6)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected RippleFunction(RippleFunction original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RippleFunction(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars) {
+      double x1 = data[vars.ElementAt(0)].Last();
+      double x2 = data[vars.ElementAt(1)].Last();
+      return (x1 - 3) * (x2 - 3) + 2 * Math.Sin((x1 - 4) * (x2 - 4));
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SalustowiczFunctionOneDimensional.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SalustowiczFunctionOneDimensional.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SalustowiczFunctionOneDimensional.cs	(revision 6968)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("Salustowicz function (1d)", "")]
+  public class SalustowiczFunctionOneDimensional : RegressionBenchmark {
+
+    public SalustowiczFunctionOneDimensional() {
+      Name = "Salustowicz function (1d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x", new IntRange(0, 10)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected SalustowiczFunctionOneDimensional(SalustowiczFunctionOneDimensional original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SalustowiczFunctionOneDimensional(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars) {
+      double x = data[vars.ElementAt(0)].Last();
+      return Math.Exp(-x) * Math.Pow(x, 3) * Math.Sin(x) * Math.Cos(x) * (Math.Pow(Math.Sin(x), 2) * Math.Cos(x) - 1);
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SalustowiczFunctionTwoDimensional.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SalustowiczFunctionTwoDimensional.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SalustowiczFunctionTwoDimensional.cs	(revision 6968)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("Salustowicz function (2d)", "")]
+  public class SalustowiczFunctionTwoDimensional : RegressionBenchmark {
+
+    public SalustowiczFunctionTwoDimensional() {
+      Name = "Salustowicz function (2d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x1", new IntRange(0, 10)},
+        {"x2", new IntRange(0, 10)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected SalustowiczFunctionTwoDimensional(SalustowiczFunctionTwoDimensional original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SalustowiczFunctionTwoDimensional(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars) {
+      double x1 = data[vars.ElementAt(0)].Last();
+      double x2 = data[vars.ElementAt(1)].Last();
+      return Math.Exp(-x1) * Math.Pow(x1, 3) * (x2 - 5) * Math.Sin(x1) * Math.Cos(x1) * (Math.Pow(Math.Sin(x1), 2) * Math.Cos(x1) - 1);
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SineCosineFunction.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SineCosineFunction.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/SineCosineFunction.cs	(revision 6968)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("SineCosine function (2d)", "")]
+  public class SineCosineFunction : RegressionBenchmark {
+
+    public SineCosineFunction() {
+      Name = "SineCosine function (2d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x1", new IntRange(0, 6)},
+        {"x2", new IntRange(0, 6)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected SineCosineFunction(SineCosineFunction original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SineCosineFunction(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(Dictionary<string, IList<double>> data, List<string> vars) {
+      double x1 = data[vars.ElementAt(0)].Last();
+      double x2 = data[vars.ElementAt(1)].Last();
+      return 6 * Math.Sin(x1) * Math.Cos(x2);
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/UnwrappedBallFunction.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/UnwrappedBallFunction.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/UnwrappedBallFunction.cs	(revision 6968)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
+  [Item("UnwrappedBall function (1d)", "")]
+  public class UnwrappedBallFunction : RegressionBenchmark {
+
+    public UnwrappedBallFunction() {
+      Name = "UnwrappedBall function (1d)";
+      TargetVariable = "y";
+      Inputvariables = new Dictionary<string, IntRange>() {
+        {"x1", new IntRange(-2, 8)}
+      };
+      AmountOfPoints = 4000;
+      TrainingPartition = new IntRange(0, 2667);
+      TestPartition = new IntRange(TrainingPartition.End, AmountOfPoints);
+    }
+
+    #region cloning
+    protected UnwrappedBallFunction(UnwrappedBallFunction original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new UnwrappedBallFunction(this, cloner);
+    }
+    #endregion
+
+    protected override double CalculateFunction(System.Collections.Generic.Dictionary<string, IList<double>> data, List<string> vars) {
+      double x1 = data[vars.ElementAt(0)].Last();
+      return 10 / (Math.Pow(x1 - 3, 2) + 5);
+    }
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/MultiObjective/SymbolicClassificationMultiObjectiveProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/MultiObjective/SymbolicClassificationMultiObjectiveProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/MultiObjective/SymbolicClassificationMultiObjectiveProblem.cs	(revision 6968)
@@ -112,4 +112,12 @@
       ProblemData = problemData;
     }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      throw new System.NotImplementedException();
+    }
+
+    public override System.Collections.Generic.IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      throw new System.NotImplementedException();
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SingleObjective/SymbolicClassificationSingleObjectiveProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SingleObjective/SymbolicClassificationSingleObjectiveProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SingleObjective/SymbolicClassificationSingleObjectiveProblem.cs	(revision 6968)
@@ -111,4 +111,12 @@
       ProblemData = problemData;
     }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      throw new System.NotImplementedException();
+    }
+
+    public override System.Collections.Generic.IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      throw new System.NotImplementedException();
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/MultiObjective/SymbolicRegressionMultiObjectiveProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/MultiObjective/SymbolicRegressionMultiObjectiveProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/MultiObjective/SymbolicRegressionMultiObjectiveProblem.cs	(revision 6968)
@@ -20,4 +20,6 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Common;
@@ -26,4 +28,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Regression {
@@ -116,4 +119,21 @@
       ProblemData = problemData;
     }
+
+    public override IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      return ApplicationManager.Manager.GetInstances<IRegressionBenchmarkProblemDataGenerator>();
+    }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      if (!(benchmarkGenerator is IRegressionBenchmarkProblemDataGenerator)) {
+        throw new ArgumentException("BenchmarkGenerator is not an IRegressionBenchmarkProblemDataGenerator.");
+      }
+
+      IDataAnalysisProblemData problemData = benchmarkGenerator.GenerateProblemData();
+
+      if (problemData is IRegressionProblemData)
+        ProblemData = (IRegressionProblemData)problemData;
+      else
+        throw new InvalidCastException("ProblemDataGenerator didn't return an IRegressionProblemData.");
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionSingleObjectiveProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionSingleObjectiveProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SingleObjective/SymbolicRegressionSingleObjectiveProblem.cs	(revision 6968)
@@ -20,4 +20,6 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Common;
@@ -25,4 +27,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Regression {
@@ -113,4 +116,21 @@
       ProblemData = problemData;
     }
+
+    public override IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      return ApplicationManager.Manager.GetInstances<IRegressionBenchmarkProblemDataGenerator>();
+    }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      if (!(benchmarkGenerator is IRegressionBenchmarkProblemDataGenerator)) {
+        throw new ArgumentException("BenchmarkGenerator is not an IRegressionBenchmarkProblemDataGenerator.");
+      }
+
+      IDataAnalysisProblemData problemData = benchmarkGenerator.GenerateProblemData();
+
+      if (problemData is IRegressionProblemData)
+        ProblemData = (IRegressionProblemData)problemData;
+      else
+        throw new InvalidCastException("ProblemDataGenerator didn't return an IRegressionProblemData.");
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis/3.4/SingleObjective/SymbolicTimeSeriesPrognosisSingleObjectiveProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis/3.4/SingleObjective/SymbolicTimeSeriesPrognosisSingleObjectiveProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis/3.4/SingleObjective/SymbolicTimeSeriesPrognosisSingleObjectiveProblem.cs	(revision 6968)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Common;
@@ -69,5 +70,5 @@
       UpdateEstimationLimits();
     }
-    
+
     private void ConfigureGrammarSymbols() {
       var grammar = SymbolicExpressionTreeGrammar as TypeCoherentExpressionGrammar;
@@ -114,4 +115,12 @@
       ProblemData = problemData;
     }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      throw new System.NotImplementedException();
+    }
+
+    public override IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      throw new System.NotImplementedException();
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisProblem.cs	(revision 6968)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.Drawing;
 using System.Linq;
@@ -310,4 +311,8 @@
 
     public abstract void ImportProblemDataFromFile(string fileName);
+
+    public abstract void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator);
+
+    public abstract IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators();
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/DataAnalysisProblemView.Designer.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/DataAnalysisProblemView.Designer.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/DataAnalysisProblemView.Designer.cs	(revision 6968)
@@ -45,6 +45,8 @@
     /// </summary>
     private void InitializeComponent() {
-      this.ImportButton = new System.Windows.Forms.Button();
+      this.importButton = new System.Windows.Forms.Button();
       this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
+      this.benchmarkComboBox = new System.Windows.Forms.ComboBox();
+      this.loadButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
@@ -66,15 +68,15 @@
       this.infoLabel.Location = new System.Drawing.Point(474, 3);
       // 
-      // ImportButton
+      // importButton
       // 
-      this.ImportButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.ImportButton.Location = new System.Drawing.Point(0, 26);
-      this.ImportButton.Name = "ImportButton";
-      this.ImportButton.Size = new System.Drawing.Size(493, 23);
-      this.ImportButton.TabIndex = 3;
-      this.ImportButton.Text = "Import from CSV file";
-      this.ImportButton.UseVisualStyleBackColor = true;
-      this.ImportButton.Click += new System.EventHandler(this.ImportButton_Click);
+      this.importButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.importButton.Location = new System.Drawing.Point(3, 24);
+      this.importButton.Name = "importButton";
+      this.importButton.Size = new System.Drawing.Size(243, 23);
+      this.importButton.TabIndex = 3;
+      this.importButton.Text = "Import from CSV file";
+      this.importButton.UseVisualStyleBackColor = true;
+      this.importButton.Click += new System.EventHandler(this.ImportButton_Click);
       // 
       // openFileDialog
@@ -82,12 +84,37 @@
       this.openFileDialog.FileName = "openFileDialog";
       // 
+      // benchmarkComboBox
+      // 
+      this.benchmarkComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.benchmarkComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.benchmarkComboBox.FormattingEnabled = true;
+      this.benchmarkComboBox.Location = new System.Drawing.Point(252, 25);
+      this.benchmarkComboBox.Name = "benchmarkComboBox";
+      this.benchmarkComboBox.Size = new System.Drawing.Size(183, 21);
+      this.benchmarkComboBox.TabIndex = 5;
+      // 
+      // loadButton
+      // 
+      this.loadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.loadButton.Location = new System.Drawing.Point(439, 24);
+      this.loadButton.Name = "loadButton";
+      this.loadButton.Size = new System.Drawing.Size(50, 23);
+      this.loadButton.TabIndex = 6;
+      this.loadButton.Text = "Load";
+      this.loadButton.UseVisualStyleBackColor = true;
+      this.loadButton.Click += new System.EventHandler(this.loadButton_Click);
+      // 
       // DataAnalysisProblemView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.ImportButton);
+      this.Controls.Add(this.loadButton);
+      this.Controls.Add(this.importButton);
+      this.Controls.Add(this.benchmarkComboBox);
       this.Name = "DataAnalysisProblemView";
       this.Size = new System.Drawing.Size(493, 334);
-      this.Controls.SetChildIndex(this.ImportButton, 0);
+      this.Controls.SetChildIndex(this.benchmarkComboBox, 0);
+      this.Controls.SetChildIndex(this.importButton, 0);
+      this.Controls.SetChildIndex(this.loadButton, 0);
       this.Controls.SetChildIndex(this.infoLabel, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
@@ -102,6 +129,8 @@
     #endregion
 
-    private System.Windows.Forms.Button ImportButton;
+    private System.Windows.Forms.Button importButton;
     private System.Windows.Forms.OpenFileDialog openFileDialog;
+    private System.Windows.Forms.ComboBox benchmarkComboBox;
+    private System.Windows.Forms.Button loadButton;
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/DataAnalysisProblemView.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/DataAnalysisProblemView.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/DataAnalysisProblemView.cs	(revision 6968)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Linq;
 using System.Windows.Forms;
 using HeuristicLab.MainForm;
@@ -41,5 +42,5 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      ImportButton.Enabled = !Locked && !ReadOnly && Content != null;
+      importButton.Enabled = !Locked && !ReadOnly && Content != null;
     }
 
@@ -54,4 +55,17 @@
       }
     }
+
+    private void loadButton_Click(object sender, EventArgs e) {
+      if (benchmarkComboBox.SelectedItem != null)
+        Content.CreateProblemDataFromBenchmark((IDataAnalysisBenchmarkProblemDataGenerator)benchmarkComboBox.SelectedItem);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      benchmarkComboBox.Items.Clear();
+      benchmarkComboBox.Items.AddRange(Content.GetBenchmarkProblemDataGenerators().OrderBy(b => b.ItemName).ToArray());
+      if (benchmarkComboBox.Items.Count > 0)
+        benchmarkComboBox.SelectedIndex = 0;
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 6968)
@@ -93,4 +93,5 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Operators-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -328,4 +329,8 @@
       <Private>False</Private>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.DebugEngine\3.3\HeuristicLab.DebugEngine-3.3.csproj">
+      <Project>{49F28045-7B5F-411B-8D59-16C846FA26E0}</Project>
+      <Name>HeuristicLab.DebugEngine-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
       <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
@@ -396,4 +401,9 @@
     </BootstrapperPackage>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="DataAnalysisProblemView.resx">
+      <DependentUpon>DataAnalysisProblemView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 6968)
@@ -138,4 +138,8 @@
     </Compile>
     <Compile Include="Interfaces\Classification\IDiscriminantFunctionThresholdCalculator.cs" />
+    <Compile Include="Interfaces\Classification\IClassificationBenchmarkProblemDataGenerator.cs" />
+    <Compile Include="Interfaces\Clustering\IClusteringBenchmarkProblemDataGenerator.cs" />
+    <Compile Include="Interfaces\IDataAnalysisBenchmarkProblemDataGenerator.cs" />
+    <Compile Include="Interfaces\Regression\IRegressionBenchmarkProblemDataGenerator.cs" />
     <Compile Include="Interfaces\Regression\IRegressionEnsembleModel.cs">
       <SubType>Code</SubType>
@@ -143,4 +147,5 @@
     <Compile Include="Interfaces\Regression\IRegressionEnsembleSolution.cs" />
     <Compile Include="Implementation\Regression\RegressionSolutionBase.cs" />
+    <Compile Include="Interfaces\TimeSeriesPrognosis\ITimeSeriesBenchmarkProblemDataGenerator.cs" />
     <Compile Include="Interfaces\TimeSeriesPrognosis\ITimeSeriesPrognosisModel.cs" />
     <Compile Include="Interfaces\TimeSeriesPrognosis\ITimeSeriesPrognosisProblem.cs" />
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblem.cs	(revision 6968)
@@ -20,7 +20,9 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -43,4 +45,12 @@
       ProblemData = problemData;
     }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      throw new System.NotImplementedException();
+    }
+
+    public override IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      return ApplicationManager.Manager.GetInstances<IClassificationBenchmarkProblemDataGenerator>();
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Clustering/ClusteringProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Clustering/ClusteringProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Clustering/ClusteringProblem.cs	(revision 6968)
@@ -23,4 +23,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -43,4 +44,12 @@
       ProblemData = problemData;
     }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      throw new System.NotImplementedException();
+    }
+
+    public override System.Collections.Generic.IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      return ApplicationManager.Manager.GetInstances<IClusteringBenchmarkProblemDataGenerator>();
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblem.cs	(revision 6968)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -92,4 +93,8 @@
 
     public abstract void ImportProblemDataFromFile(string fileName);
+
+    public abstract void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator);
+
+    public abstract IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators();
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblem.cs	(revision 6968)
@@ -20,7 +20,10 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -43,4 +46,21 @@
       ProblemData = problemData;
     }
+
+    public override IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      return ApplicationManager.Manager.GetInstances<IRegressionBenchmarkProblemDataGenerator>();
+    }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      if (!(benchmarkGenerator is IRegressionBenchmarkProblemDataGenerator)) {
+        throw new ArgumentException("BenchmarkGenerator is not an IRegressionBenchmarkProblemDataGenerator.");
+      }
+
+      IDataAnalysisProblemData problemData = benchmarkGenerator.GenerateProblemData();
+
+      if (problemData is IRegressionProblemData)
+        ProblemData = (IRegressionProblemData)problemData;
+      else
+        throw new InvalidCastException("ProblemDataGenerator didn't return an IRegressionProblemData.");
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisProblem.cs	(revision 6968)
@@ -20,7 +20,9 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -43,4 +45,12 @@
       ProblemData = problemData;
     }
+
+    public override void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator) {
+      throw new System.NotImplementedException();
+    }
+
+    public override IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators() {
+      return ApplicationManager.Manager.GetInstances<ITimeSeriesBenchmarkProblemDataGenerator>();
+    }
   }
 }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IClassificationBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IClassificationBenchmarkProblemDataGenerator.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IClassificationBenchmarkProblemDataGenerator.cs	(revision 6968)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  public interface IClassificationBenchmarkProblemDataGenerator : IDataAnalysisBenchmarkProblemDataGenerator {
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Clustering/IClusteringBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Clustering/IClusteringBenchmarkProblemDataGenerator.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Clustering/IClusteringBenchmarkProblemDataGenerator.cs	(revision 6968)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  public interface IClusteringBenchmarkProblemDataGenerator : IDataAnalysisBenchmarkProblemDataGenerator {
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisBenchmarkProblemDataGenerator.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisBenchmarkProblemDataGenerator.cs	(revision 6968)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using HeuristicLab.Core;
+namespace HeuristicLab.Problems.DataAnalysis {
+  public interface IDataAnalysisBenchmarkProblemDataGenerator : IItem {
+    IDataAnalysisProblemData GenerateProblemData();
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblem.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblem.cs	(revision 6965)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblem.cs	(revision 6968)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
@@ -31,4 +32,6 @@
 
     void ImportProblemDataFromFile(string fileName);
+    void CreateProblemDataFromBenchmark(IDataAnalysisBenchmarkProblemDataGenerator benchmarkGenerator);
+    IEnumerable<IDataAnalysisBenchmarkProblemDataGenerator> GetBenchmarkProblemDataGenerators();
   }
 
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionBenchmarkProblemDataGenerator.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionBenchmarkProblemDataGenerator.cs	(revision 6968)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  public interface IRegressionBenchmarkProblemDataGenerator : IDataAnalysisBenchmarkProblemDataGenerator {
+  }
+}
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/TimeSeriesPrognosis/ITimeSeriesBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/TimeSeriesPrognosis/ITimeSeriesBenchmarkProblemDataGenerator.cs	(revision 6968)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/TimeSeriesPrognosis/ITimeSeriesBenchmarkProblemDataGenerator.cs	(revision 6968)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  public interface ITimeSeriesBenchmarkProblemDataGenerator : IDataAnalysisBenchmarkProblemDataGenerator {
+  }
+}
